it-swarm-ru.tech

Баш: печать stderr в красный цвет

Есть ли способ сделать Bash Display sTDERR сообщения в красном цвете?

124
kolypto
command 2> >(while read line; do echo -e "\e[01;31m$line\e[0m" >&2; done)
103
Balázs Pozsár

Метод 1: Используйте процесс замены:

command 2> >(sed $'s,.*,\e[31m&\e[m,'>&2)

Способ 2: создать функцию в скрипте bash:

color()(set -o pipefail;"[email protected]" 2>&1>&3|sed $'s,.*,\e[31m&\e[m,'>&2)3>&1

Используйте это так:

$ color command

Оба метода покажут stderr команды красным цветом.

Продолжайте читать, чтобы объяснить, как работает метод 2. Эта команда демонстрирует некоторые интересные особенности.

  • color()... - создает функцию bash с именем color.
  • set -o pipefail - это параметр оболочки, в котором сохраняется код возврата ошибки команды, выходные данные которой передаются в другую команду. Это делается в подоболочке, которая создается в скобках, чтобы не изменять параметр pipefail во внешней оболочке.
  • "[email protected]" - выполняет аргументы функции в виде новой команды. "[email protected]" эквивалентно "$1" "$2" ...
  • 2>&1 - Перенаправляет stderr команды на stdout, чтобы она стала sedstdin.
  • >&3 - Сокращение для 1>&3, это перенаправляет stdout на новый дескриптор временного файла 3. 3 будет перенаправлен обратно в stdout позже.
  • sed ... - Из-за перенаправлений, указанных выше, sedstdin является stderr выполненной команды. Его функция заключается в том, чтобы окружать каждую строку цветовыми кодами.
  • $'...' Конструкция bash, которая заставляет его понимать символы с обратной косой чертой
  • .* - Соответствует всей строке.
  • \e[31m - escape-последовательность ANSI, в результате которой следующие символы становятся красными
  • & - Символ замены sed, который расширяется до всей совпадающей строки (в данном случае всей строки).
  • \e[m - escape-последовательность ANSI, которая сбрасывает цвет.
  • >&2 - Сокращение для 1>&2, это перенаправляет sedstdout на stderr.
  • 3>&1 - Перенаправляет дескриптор временного файла 3 обратно в stdout.
93
killdash9

Вы также можете проверить stderred: https://github.com/sickill/stderred

29
sickill

В bash способ сделать stderr постоянно красным использует exec для перенаправления потоков. Добавьте следующее в ваш bashrc:

exec 9>&2
exec 8> >(
    while IFS='' read -r line || [ -n "$line" ]; do
       echo -e "\033[31m${line}\033[0m"
    done
)
function undirect(){ exec 2>&9; }
function redirect(){ exec 2>&8; }
trap "redirect;" DEBUG
Prompt_COMMAND='undirect;'

Я уже писал об этом ранее: Как установить цвет шрифта для STDOUT и STDERR

17
gospes
14
quaie

Я сделал скрипт-обертку, который реализует ответ Balázs Pozsár на чистом bash. Сохраните его в ваших командах $ PATH и префиксе, чтобы раскрасить их вывод.

 
 #!/bin/bash 
 
 if [$ 1 == "--help"]; then 
 echo "Выполняет команду и раскрашивает все возникшие ошибки" 
 echo "Пример:` basename $ {0} `wget ..." 
 echo "(c) o_O Tync , ICQ # 1227-700, наслаждайтесь! "
 Выход 0 
 Fi 
 
 # Временный файл, чтобы перехватить все ошибки 
 TMP_ERRS = $ (mktemp) ) 
 
 # Выполнить команду 
 "$ @" 2>> (во время чтения строки; выполнить echo -e "\ e [01; 31m $ line\e [0m" | tee --append $ TMP_ERRS; готово) 
 EXIT_CODE = $? 
 
 # Снова отобразить все ошибки 
 if [-s "$ TMP_ERRS"]; затем 
 echo -e "\ n\n\n\e [01; 31m === ОШИБКИ ===\e [0m" 
 cat $ TMP_ERRS 
 fi 
 rm -f $ TMP_ERRS 
 
 # Завершить 
 выход $ EXIT_CODE 
 
7
kolypto

Вы можете использовать такую ​​функцию


 #!/bin/sh

color() {
      printf '\033[%sm%s\033[m\n' "[email protected]"
      # usage color "31;5" "string"
      # 0 default
      # 5 blink, 1 strong, 4 underlined
      # fg: 31 red,  32 green, 33 yellow, 34 blue, 35 purple, 36 cyan, 37 white
      # bg: 40 black, 41 red, 44 blue, 45 purple
      }
string="Hello world!"
color '31;1' "$string" >&2
</ Код>

Я добавляю> & 2 для печати в stderr

3
Ali Mezgani

Это решение работает для меня: https://superuser.com/questions/28869/immediately-tell-which-output-was-sent-to-stderr

Я поместил эту функцию в моем .bashrc или .zshrc:

# Red STDERR
# rse <command string>
function rse()
{
    # We need to wrap each phrase of the command in quotes to preserve arguments that contain whitespace
    # Execute the command, swap STDOUT and STDERR, colour STDOUT, swap back
    ((eval $(for phrase in "[email protected]"; do echo -n "'$phrase' "; done)) 3>&1 1>&2 2>&3 | sed -e "s/^\(.*\)$/$(echo -en \\033)[31;1m\1$(echo -en \\033)[0m/") 3>&1 1>&2 2>&3
}

Тогда, например:

$ rse cat non_existing_file.txt

даст мне красный вывод.

1
Eyal Levin

используя xargs и printf:

command 2> >(xargs -0 printf "\e[31m%s\e[m" >&2)
1
Carlos Barcellos

У меня есть слегка измененная версия сценария О_о Тюнка. Мне нужно было сделать эти моды для OS X Lion, и они не идеальны, потому что сценарий иногда завершается раньше, чем обернутая команда. Я добавил сон, но я уверен, что есть лучший способ.

#!/bin/bash

   if [ $1 == "--help" ] ; then
       echo "Executes a command and colorizes all errors occured"
       echo "Example: `basename ${0}` wget ..."
       echo "(c) o_O Tync, ICQ# 1227-700, Enjoy!"
       exit 0
       fi

   # Temp file to catch all errors
   TMP_ERRS=`mktemp /tmp/temperr.XXXXXX` || exit 1

   # Execute command
   "[email protected]" 2> >(while read line; do echo -e "$(tput setaf 1)$line\n" | tee -a $TMP_ERRS; done)
   EXIT_CODE=$?

   sleep 1
   # Display all errors again
   if [ -s "$TMP_ERRS" ] ; then
       echo -e "\n\n\n$(tput setaf 1) === ERRORS === "
       cat $TMP_ERRS
   else
       echo "No errors collected in $TMP_ERRS"
   fi
   rm -f $TMP_ERRS

   # Finish
   exit $EXIT_CODE
1
Cliff

версия, использующая fifos

mkfifo errs
stdbuf -o0 -e0 -i0 grep . foo | while read line; do echo -e "\e[01;31m$line  \e[0m" >&2; done &
stdbuf -o0 -e0 -i0 sh $script 2>errs
0
untore